@echo off

echo.
echo.|set /p ="Unregistering C= package... "

pushd

cd %~dp0

rem Detect processor architecture

IF "%PROCESSOR_ARCHITECTURE%" == "AMD64" GOTO :x64

IF "%PROCESSOR_ARCHITECTURE%" NEQ "x86" GOTO :error

IF "%PROCESSOR_ARCHITEW6432%" NEQ "AMD64" GOTO :x86

rem Remove C= DLL from the system folder

:x64

del "%SystemRoot%\System32\C=.dll" >NUL 2>NUL
del "%SystemRoot%\System32\C=.pdb" >NUL 2>NUL
del "%SystemRoot%\Sysnative\C=.dll" >NUL 2>NUL
del "%SystemRoot%\Sysnative\C=.pdb" >NUL 2>NUL
del "%SystemRoot%\sysWOW64\C=.dll" >NUL 2>NUL
del "%SystemRoot%\sysWOW64\C=.pdb" >NUL 2>NUL

set cmd="%SystemRoot%\sysWOW64\cmd.exe"

GOTO :msvc

:x86

del "%SystemRoot%\system32\C=.dll" >NUL 2>NUL
del "%SystemRoot%\system32\C=.pdb" >NUL 2>NUL

set cmd="%SystemRoot%\system32\cmd.exe"

:msvc

rem Detect MSVS installation folder

IF x%1==x GOTO :defaults

call reghlp3.bat %1 >NUL 2>NUL

GOTO :done

:defaults

call %cmd% /c reghlp4.bat >NUL 2>NUL

:done

popd

echo done

GOTO :EOF

:error

echo ERROR: Wrong system architecture

popd
