@echo off

if %1x == x goto usage


rem Create session

set /A cosession = %RANDOM%

del /P /F /S /Q %TEMP%\%cosession% >NUL 2>NUL

mkdir %TEMP%\%cosession% >NUL 2>NUL

pushd

cd %~dp0

copy x86\coagent.exe %TEMP%\%cosession%\%cosession%.coagent32.exe >NUL 2>NUL
copy x64\coagent.exe %TEMP%\%cosession%\%cosession%.coagent64.exe >NUL 2>NUL

popd


rem Check if coload configuration is specified

if [%1]==[] goto defspec

set /A num=%1

if [%num%]==[%1] goto setspec

:defspec

rem Count DLLs to offload

pushd

cd %~dp1

set dllcount=0

for /R %%A in (*_net.dll) do set /A dllcount += 1

popd


rem Detect processor architecture

IF "%PROCESSOR_ARCHITECTURE%" == "AMD64" GOTO :x64

IF "%PROCESSOR_ARCHITECTURE%" NEQ "x86" GOTO :error

IF "%PROCESSOR_ARCHITEW6432%" NEQ "AMD64" GOTO :x86


rem Launch coloading agents

:x64

for /L %%A in (1, 1, %dllcount%) do start /B %TEMP%\%cosession%\%cosession%.coagent64.exe %TEMP%\%cosession% >NUL 2>NUL

:x86

for /L %%A in (1, 1, %dllcount%) do start /B %TEMP%\%cosession%\%cosession%.coagent32.exe %TEMP%\%cosession% >NUL 2>NUL


rem Run app

set CPX_NETLOAD_SERVER=%TEMP%\%cosession%

%*

:destroy

rem Kill coloading agents

taskkill /T /F /IM %cosession%.coagent32.exe >NUL 2>NUL
taskkill /T /F /IM %cosession%.coagent64.exe >NUL 2>NUL


rem Delete session

rmdir /S /Q %TEMP%\%cosession% >NUL 2>NUL

set CPX_NETLOAD_SERVER=
set cosession=
set lvl=
set num=

goto done


rem Print help

:usage

echo.
echo Multiprocess parallel work offloading utility
echo ---
echo Usage: mprun your_app_to_run your_apps_parameters
echo.
echo    Or: mprun [X Y Z ...] your_app_to_run your_apps_parameters
echo.
echo        wherein optional X Y Z etc. parameters specify the number of agents
echo        to launch at level 0 (X), level 1 (Y) and so on;
echo        note that the original app offloads work to level 0,
echo        code offloaded to level 0 offloads work to level 1, and so forth;
echo        also note that X Y Z are positive numbers above 0.
echo.
echo  Note: Please specify full path to your app

goto done


:setspec

rem Decode configuration, set up server env., and launch agents

:numloop

if [%1]==[] goto numloop_exit

set /A num=%1

if not [%num%]==[%1] goto numloop_exit

mkdir %TEMP%\%cosession%\%lvl% >NUL 2>NUL

rem ---

IF "%PROCESSOR_ARCHITECTURE%" == "AMD64" GOTO :x64_

IF "%PROCESSOR_ARCHITECTURE%" NEQ "x86" GOTO :error

IF "%PROCESSOR_ARCHITEW6432%" NEQ "AMD64" GOTO :x86_


rem Launch coloading agents

:x64_

for /L %%A in (1, 1, %num%) do start /B %TEMP%\%cosession%\%cosession%.coagent64.exe %TEMP%\%cosession%\%lvl% >NUL 2>NUL

:x86_

for /L %%A in (1, 1, %num%) do start /B %TEMP%\%cosession%\%cosession%.coagent32.exe %TEMP%\%cosession%\%lvl% >NUL 2>NUL

rem ---

set lvl=%lvl%_

shift

goto numloop

:numloop_exit


rem Launch the app

set appargs=%1

:apploop

shift

if [%1]==[] goto apploop_exit

set appargs=%appargs% %1

goto apploop

:apploop_exit

set CPX_NETLOAD_SERVER=%TEMP%\%cosession%

%appargs%

goto destroy


:error

echo ERROR: Wrong system architecture

:done
