@echo off

echo.
echo.|set /p ="Registering C= package... "

pushd

cd %~dp0

rem Detect processor architecture

IF "%PROCESSOR_ARCHITECTURE%" == "AMD64" GOTO :x64

IF "%PROCESSOR_ARCHITECTURE%" NEQ "x86" GOTO :error

IF "%PROCESSOR_ARCHITEW6432%" NEQ "AMD64" GOTO :x86

rem Copy C= DLL to the system folder

:x64

copy "x64\C=.dll" "%SystemRoot%\System32\C=.dll" >NUL 2>NUL
copy "x64\C=.pdb" "%SystemRoot%\System32\C=.pdb" >NUL 2>NUL
copy "x64\C=.dll" "%SystemRoot%\Sysnative\C=.dll" >NUL 2>NUL
copy "x64\C=.pdb" "%SystemRoot%\Sysnative\C=.pdb" >NUL 2>NUL
copy "x86\C=.dll" "%SystemRoot%\sysWOW64\C=.dll" >NUL 2>NUL
copy "x86\C=.pdb" "%SystemRoot%\sysWOW64\C=.pdb" >NUL 2>NUL

set cmd="%SystemRoot%\sysWOW64\cmd.exe"

GOTO :msvc

:x86

copy "x86\C=.dll" "%SystemRoot%\system32\C=.dll" >NUL 2>NUL
copy "x86\C=.pdb" "%SystemRoot%\system32\C=.pdb" >NUL 2>NUL

set cmd="%SystemRoot%\system32\cmd.exe"

:msvc

rem Detect MSVS installation folder

IF x%1==x GOTO :defaults

call reghlp1.bat %1 >NUL 2>NUL

GOTO :done

:defaults

call %cmd% /c reghlp5.bat >NUL 2>NUL

:done

popd

echo done

GOTO :EOF

:error

echo ERROR: Wrong system architecture

popd
